package com.hisschemoller 
{
	import com.hisschemoller.view.components.Alert;
	import com.hisschemoller.view.components.AppBase;
	import com.hisschemoller.view.components.ControlBar;
	import com.hisschemoller.view.components.Output;

	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Apr 2, 2010
	 * 
	 * Version 1.1
	 * DONE: Display code from proxy to view component.
	 * DONE: Display code reads Vector of SampleVO objects instead of ByteArray.
	 * DONE: Make buffer Vector of SampleVO objects instead of two Vectors of numbers.
	 * DONE: Controls section no longer part of an editor instrument.
	 * DONE: Resizable wave display.
	 * DONE: New WaveDisplayControls + WaveDisplayControlsMediator classes.
	 * DONE: Mono WAV export when mono file was opened.
	 * DONE: Loop on/off button and implementation.
	 * DONE: Loop start and end change updated while playing.
	 * DONE: Get the playbar at the right position.
	 * TODO: Draggable play locator.
	 * MAYBE: Keyboard play mode.
	 * MAYBE: Chunk processing while file decoding.
	 * MAYBE: Spinner to indicate app is busy.
	 * MAYBE: Crossfade loop code and slider.
	 * MAYBE: Dispose code for garbage collection.
	 */
	public class App extends Sprite 
	{
		public var appBase : AppBase;
		public var output : Output;
		public var controlBar : ControlBar;
		public var alert : Alert;
		
		public function App()
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.quality = StageQuality.BEST;
			stage.showDefaultContextMenu = false;
			
			initUI();
			initPureMVC();
		}

		/**
		 * 
		 */
		private function initUI() : void
		{
			appBase = new AppBase(this);
			output = new Output(this);
			controlBar = new ControlBar(this);
			alert = new Alert(this);
		}

		/**
		 * 
		 */
		private function initPureMVC() : void
		{
			AppFacade.getInstance().startup(this);
		}
	}
}
