package com.hisschemoller 
{
	import com.hisschemoller.controller.AddNewSoundCommand;
	import com.hisschemoller.controller.FileDataCommand;
	import com.hisschemoller.controller.FileOpenCommand;
	import com.hisschemoller.controller.FileSaveCommand;
	import com.hisschemoller.controller.StartupCommand;
	import com.hisschemoller.controller.StartupDoneCommand;
	import com.hisschemoller.controller.StartupInstrumentsCommand;
	
	import org.puremvc.as3.interfaces.IFacade;
	import org.puremvc.as3.patterns.facade.Facade;
	import org.puremvc.as3.patterns.observer.Notification;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Mar 26, 2010
	 */
	public class AppFacade extends Facade implements IFacade 
	{
		/** Notification name constants. */
		public static const STARTUP : String = "startup";
		public static const STARTUP_INSTRUMENTS : String = "startupInstruments";
		public static const STARTUP_DONE : String = "startupDone";
		public static const FILE_OPEN : String = "fileOpen";
		public static const FILE_DATA : String = "fileData";
		public static const FILE_SAVE : String = "fileSave";
		public static const ADD_SOUND : String = "addSound";
		public static const ADD_INSTRUMENT : String = "addInstrument";
		public static const ALERT : String = "alert";
		public static const PROCESSOR_ADDED : String = "processorAdded";
		public static const PROCESSOR_REMOVED : String = "processorRemoved";

		/**
		 * Singleton ApplicationFacade Factory Method
		 */
		public static function getInstance() : AppFacade 
		{
			if(instance == null) instance = new AppFacade();
			
			return instance as AppFacade;
		}

		/**
		 * Broadcast the STARTUP Notification
		 */
		public function startup(app : Object) : void 
		{
			notifyObservers(new Notification(AppFacade.STARTUP, app));
		}

		/**
		 * Register Commands with the Controller
		 */
		override protected function initializeController() : void 
		{
			super.initializeController();
			
			registerCommand(AppFacade.STARTUP, StartupCommand);
			registerCommand(AppFacade.STARTUP_INSTRUMENTS, StartupInstrumentsCommand);
			registerCommand(AppFacade.STARTUP_DONE, StartupDoneCommand);
			registerCommand(AppFacade.FILE_DATA, FileDataCommand);
			registerCommand(AppFacade.FILE_OPEN, FileOpenCommand);
			registerCommand(AppFacade.FILE_SAVE, FileSaveCommand);
			registerCommand(AppFacade.ADD_SOUND, AddNewSoundCommand);
		}
	}
}
