package com.hisschemoller.controller 
{
	import com.hisschemoller.App;
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.model.AudioDriverProxy;
	import com.hisschemoller.model.AudioEngineProxy;
	import com.hisschemoller.model.AudioOutputProxy;
	import com.hisschemoller.model.SoundBankProxy;
	import com.hisschemoller.model.enum.FileDataType;
	import com.hisschemoller.view.AlertMediator;
	import com.hisschemoller.view.AppMediator;
	import com.hisschemoller.view.ControlBarMediator;
	import com.hisschemoller.view.OutputMediator;

	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class StartupCommand extends SimpleCommand implements ICommand 
	{
		/**
		 * Register the Proxies and Mediators.
		 */
		override public function execute(note : INotification) : void
		{
			var app : App = note.getBody() as App;
			
			/** Create and register proxies. */
			facade.registerProxy(new AudioEngineProxy());
			facade.registerProxy(new AudioOutputProxy());
			facade.registerProxy(new AudioDriverProxy(app.stage));
			facade.registerProxy(new SoundBankProxy());
			
			/** Create and register mediators. */
			facade.registerMediator(new AppMediator(app));
			facade.registerMediator(new OutputMediator(app.output));
			facade.registerMediator(new ControlBarMediator(app.controlBar));
			facade.registerMediator(new AlertMediator(app.alert));
			
			/** Load the XML with program data. */
			facade.sendNotification(AppFacade.FILE_DATA, "../xml/config.xml", FileDataType.STARTUP_XML_FILE);
		}
	}
}
