package com.hisschemoller.utils.audio.processors 
{
	import com.hisschemoller.utils.audio.vo.SampleVO;
	import com.hisschemoller.utils.midi.MidiNoteOffVO;
	import com.hisschemoller.utils.midi.MidiNoteOnVO;
	import com.hisschemoller.utils.midi.MidiProgramChangeVO;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Feb 23, 2010
	 */
	public interface IAudioInstrument 
	{
		function noteOn(data : MidiNoteOnVO) : void;

		function noteOff(data : MidiNoteOffVO) : void;

		function programChange(data : MidiProgramChangeVO) : void;

		function allNotesOff() : void;
		
		function get id() : String;

		function addProgram(programXML : XML) : int

		function process(buffer : Vector.<SampleVO>, bufferStartIndex : uint) : void;
	}
}
