package com.hisschemoller.view 
{
	import com.hisschemoller.model.AudioDriverProxy;
	import com.hisschemoller.model.AudioOutputProxy;
	import com.hisschemoller.model.vo.AudioStreamInfoVO;
	import com.hisschemoller.view.components.Output;
	
	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;
	
	import flash.events.Event;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 26, 2010
	 */
	public class OutputMediator extends Mediator implements IMediator 
	{
		public static const NAME : String = "OutputMediator";
		private var _outputProxy : AudioOutputProxy;
		
		public function OutputMediator(viewComponent : Object = null)
		{
			super(NAME, viewComponent);
		}
		
		/**
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [ AudioDriverProxy.ENTER_FRAME,
					 AudioOutputProxy.OUTPUT_GAIN_CHANGED ];
		}
		
		/**
		 * 
		 */
		override public function handleNotification(notification : INotification) : void
		{
			switch(notification.getName())
			{
				case AudioDriverProxy.ENTER_FRAME:
					var streamInfo : AudioStreamInfoVO = AudioStreamInfoVO(notification.getBody());
					output.updateLevels(streamInfo.peakLevelLeft, streamInfo.peakLevelRight);
					break;
					
				case AudioOutputProxy.OUTPUT_GAIN_CHANGED:
					output.updateFaderLabel(Number(notification.getBody()));
					break;
			}
		}
		
		/**
		 * 
		 */
		override public function onRegister() : void
		{
			_outputProxy = AudioOutputProxy(facade.retrieveProxy(AudioOutputProxy.NAME));
			
			output.levelSliderValue = _outputProxy.decibelNormalized;
			output.updateFaderLabel(_outputProxy.decibel);
			output.addEventListener(Output.LEVEL_CHANGE, levelChangeHandler);
		}

		/**
		 * 
		 */
		private function levelChangeHandler(event : Event) : void
		{
			_outputProxy.decibelNormalized = output.levelSliderValue;
		}

		/**
		 * 
		 */
		private function get output() : Output
		{
			return viewComponent as Output;
		}
	}
}
