package com.hisschemoller.view 
{
	import com.hisschemoller.model.WaveEditorProxy;
	import com.hisschemoller.utils.audio.vo.SoundVO;
	import com.hisschemoller.view.components.WaveDisplayOverlay;

	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Apr 5, 2010
	 */
	public class WaveDisplayOverlayMediator extends Mediator implements IMediator 
	{
		public static const NAME_SUFFIX : String = "_WaveDisplayOverlay";
		
		public function WaveDisplayOverlayMediator(name : String, viewComponent : Object)
		{
			super(name, viewComponent);
		}

		/**
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [WaveEditorProxy.PROGRAM_SOUND_CHANGED];
		}

		/**
		 * 
		 */
		override public function handleNotification(notification : INotification) : void
		{
			switch(notification.getName())
			{
				case WaveEditorProxy.PROGRAM_SOUND_CHANGED:
					overlay.updateChannels(SoundVO(notification.getBody()).channels);
					break;
			}
		}

		/**
		 * 
		 */
		private function get overlay() : WaveDisplayOverlay
		{
			return viewComponent as WaveDisplayOverlay;
		}
	}
}
