package com.hisschemoller.view.components 
{
	import com.bit101.components.Component;
	import com.hisschemoller.view.components.ui.TextButton;
	import com.hisschemoller.view.components.ui.TextKeyButton;

	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.ui.Keyboard;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 5, 2010
	 */
	public class ControlBar extends Component 
	{
		public static const PLAY_PRESSED : String = "playPressed";
		public static const PLAY_RELEASED : String = "playReleased";
		public static const OPEN_BUTTON_CLICK : String = "openButtonClick";
		public static const SAVE_BUTTON_CLICK : String = "saveButtonClick";
		public static const ABOUT_BUTTON_CLICK : String = "aboutButtonClick";
		private var _openButton : TextButton;
		private var _saveButton : TextButton;
		private var _playButton : TextKeyButton;
		private var _helpButton : TextButton;
		private var _aboutButton : TextButton;
		private var _help : Help;

		public function ControlBar(container : DisplayObjectContainer)
		{
			super(container);
		}

		/**
		 * 
		 */
		override public function draw() : void
		{
			x = 10;
			y = Math.max(510, stage.stageHeight - 30);
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			_openButton = new TextButton(this, 0, 0, "open", mouseEventHandler);
			
			_saveButton = new TextButton(this, 100, 0, "save as", mouseEventHandler);
			
			_playButton = new TextKeyButton(this, 200, 0, "play sound", null, Keyboard.SPACE);
			_playButton.addEventListener(MouseEvent.MOUSE_DOWN, mouseEventHandler);
			_playButton.addEventListener(MouseEvent.MOUSE_UP, mouseEventHandler);
			
			_helpButton = new TextButton(this, 300, 0, "help", mouseEventHandler);
			
			_aboutButton = new TextButton(this, 400, 0, "about", mouseEventHandler);
			
			_help = new Help(stage);
			_help.setSize(540, 540);
			
			stage.addEventListener(Event.RESIZE, stageResizeHandler);
		}

		/**
		 * 
		 */
		private function mouseEventHandler(event : MouseEvent) : void
		{
			switch(event.type)
			{
				case MouseEvent.MOUSE_DOWN:
					dispatchEvent(new Event(ControlBar.PLAY_PRESSED));
					break;
				case MouseEvent.MOUSE_UP:
					dispatchEvent(new Event(ControlBar.PLAY_RELEASED));
					break;
				case MouseEvent.CLICK:
					switch(event.target)
					{
						case _openButton:
							dispatchEvent(new Event(ControlBar.OPEN_BUTTON_CLICK));
							break;
						case _saveButton:
							dispatchEvent(new Event(ControlBar.SAVE_BUTTON_CLICK));
							break;
						case _helpButton:
							_help.show();
							break;
						case _aboutButton:
							dispatchEvent(new Event(ControlBar.ABOUT_BUTTON_CLICK));
							break;
					}
					break;
			}
		}
		
		/**
		 * 
		 */
		private function stageResizeHandler(event : Event) : void
		{
			invalidate();
		}
	}
}
