package com.hisschemoller.view.components 
{
	import assets.OutputAsset;

	import com.bit101.components.Component;
	import com.bit101.components.Slider;
	import com.hisschemoller.view.components.enum.Colors;
	import com.hisschemoller.view.components.text.BodyText;
	import com.hisschemoller.view.components.ui.BasicSlider;

	import flash.display.DisplayObjectContainer;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormatAlign;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 26, 2010
	 */
	public class Output extends Component 
	{
		public static const LEVEL_CHANGE : String = "levelChange";
		private var _levelSlider : BasicSlider;
		private var _clipL : MovieClip;
		private var _clipR : MovieClip;
		private var _clipButton : MovieClip;
		private var _levelR : MovieClip;
		private var _levelL : MovieClip;
		private var _levelLabel : BodyText;
		private var _maxHeight : Number;
		
		public function Output(container : DisplayObjectContainer)
		{
			super(container);
		}
		
		/**
		 * 
		 */
		public function updateLevels(leftLevel : Number, rightLevel : Number) : void
		{
			_levelL.height = leftLevel * _maxHeight;
			_levelR.height = rightLevel * _maxHeight;
			
			if(leftLevel > 1) _clipL.gotoAndStop(2);
			if(rightLevel > 1) _clipR.gotoAndStop(2);
		}
		
		/**
		 * @param value: 
		 */
		public function updateFaderLabel(value : Number) : void
		{
			 _levelLabel.text = value.toFixed(2) + " dB";
		}
		
		/**
		 * 
		 */
		public function get levelSliderValue() : Number
		{
			return _levelSlider.value; //  * 1.9952623149688797;
		}
		
		public function set levelSliderValue(value : Number) : void
		{
			_levelSlider.value = value;
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			var outputAsset : OutputAsset = new OutputAsset();
			addChild(outputAsset);
			
			_maxHeight = outputAsset.tLevelL.height;
			
			_levelSlider = new BasicSlider(Slider.VERTICAL, this, 464, 20, levelSliderChangeHandler);
			_levelSlider.setSliderParams(0, 1, 0);
			_levelSlider.setSize(12, 112);
			
			_levelLabel = new BodyText(11, Colors.WHITE, 85);
			_levelLabel.align = TextFormatAlign.RIGHT;
			_levelLabel.autoSize = TextFieldAutoSize.RIGHT;
			_levelLabel.x = 455;
			_levelLabel.y = 16;
			addChild(_levelLabel);
			
			_levelL = outputAsset.tLevelL;
			_levelL.height = 0;
			
			_levelR = outputAsset.tLevelR;
			_levelR.height = 0;
			
			_clipL = outputAsset.tClipL;
			_clipR = outputAsset.tClipR;
			
			_clipButton = outputAsset.tClipButton;
			_clipButton.addEventListener(MouseEvent.CLICK, clipButtonClickHandler);
		}

		/**
		 * 
		 */
		private function levelSliderChangeHandler(event : Event) : void
		{
			dispatchEvent(new Event(Output.LEVEL_CHANGE));
		}

		/**
		 * 
		 */
		private function clipButtonClickHandler(event : MouseEvent) : void
		{
			_clipL.gotoAndStop(1);
			_clipR.gotoAndStop(1);
		}
	}
}
