package com.hisschemoller.view.components 
{
	import de.popforge.audio.output.Audio;

	import com.bit101.components.Component;
	import com.hisschemoller.view.components.enum.Colors;

	import flash.display.DisplayObjectContainer;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Apr 4, 2010
	 */
	public class WaveDisplayOverlay extends Component 
	{
		private var _channels : int;
		
		public function WaveDisplayOverlay(parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0)
		{
			super(parent, xpos, ypos);
		}

		/**
		 * Redraws the display.
		 */
		override public function draw() : void
		{
			graphics.clear();
			
			graphics.lineStyle(1, Colors.RUBY_RED, 0.25);
			graphics.moveTo(_width * 0.5, 0);
			graphics.lineTo(_width * 0.5, _height);
			
			switch(_channels)
			{
				case Audio.MONO:
					graphics.moveTo(0, _height * 0.5);
					graphics.lineTo(_width, _height * 0.5);
					break;
				case Audio.STEREO:
					graphics.moveTo(0, _height * 0.25);
					graphics.lineTo(_width, _height * 0.25);
					graphics.moveTo(0, _height * 0.75);
					graphics.lineTo(_width, _height * 0.75);
					graphics.lineStyle(2, Colors.ORANGE);
					graphics.moveTo(0, _height * 0.5);
					graphics.lineTo(_width, _height * 0.5);
					break;
			}
		}
		
		/**
		 * 
		 */
		public function updateChannels(channels : int) : void
		{
			_channels = channels;
			
			invalidate();
		}
	}
}
