package com.hisschemoller.view.components.text 
{
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Mar 16, 2010
	 */
	public class FormattedTextField extends TextField 
	{
		public static const PASSWORD : String = "password";

		public function FormattedTextField(textFormat : TextFormat, fontSize : Number, color : Number, w : int = 0, isMultiline : Boolean = false, aliasType : String = "advanced")
		{
			super();
			mouseEnabled = false;
			textFormat.size = fontSize;
			defaultTextFormat = textFormat;
			antiAliasType = aliasType;
			border = false;
			selectable = false;
			embedFonts = true;
			textColor = color;
			autoSize = (isMultiline) ? TextFieldAutoSize.LEFT : TextFieldAutoSize.NONE;
			multiline = isMultiline;
			wordWrap = isMultiline;
			width = w;
			
			if(!isMultiline) height = fontSize + 2 + Number(textFormat.leading);
		}
		
		/**
		 * 
		 */
		public function set align(alignType : String) : void
		{
			switch(alignType)
			{
				case TextFormatAlign.CENTER:
				case TextFormatAlign.JUSTIFY:
				case TextFormatAlign.LEFT:
				case TextFormatAlign.RIGHT:
					var textFormat : TextFormat = defaultTextFormat;
					textFormat.align = alignType;
					defaultTextFormat = textFormat;
					break;
			}
		}
	}
}
