package com.hisschemoller.view.components.ui 
{
	import com.bit101.components.PushButton;
	import com.hisschemoller.view.components.enum.Colors;

	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Mar 22, 2010
	 */
	public class BasicLocator extends PushButton 
	{
		protected var _hitArea : Sprite;
		protected var _background : Sprite;
		
		public function BasicLocator(parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0, defaultHandler : Function = null)
		{
			super(parent, xpos, ypos, "", defaultHandler);
		}

		/**
		 * Draws the visual ui of the component.
		 */
		override public function draw() : void
		{
			var color : uint = Colors.RUBY_RED;
			
			if(_enabled)
			{
				if(_over)
				{
					color = Colors.BLOOD_RED;
				}
				else
				{
				}
				
				if(_down)
				{
					color = Colors.DARK_CHERRY_RED;
				}
			}
			else /** Disabled. */
			{
				color = Colors.BLOOD_RED;
			}
			
			if(_selected)
			{
				
			}
			else
			{
			}
			
			var transform : ColorTransform = _background.transform.colorTransform;
			transform.color = color;
			_background.transform.colorTransform = transform;
			
			graphics.clear();
			graphics.lineStyle(1, color);
			graphics.lineTo(0, _height);
		}
		
		/**
		 * Initializes the component.
		 */
		override protected function init():void
		{
			mouseChildren = false;
			super.init();
		}

		/**
		 * Creates and adds the child display objects of this component.
		 */
		override protected function addChildren() : void
		{
			if(_hitArea) hitArea = _hitArea;
			
			addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			addEventListener(MouseEvent.ROLL_OVER, onMouseOver);
		}
		
		/**
		 * Internal mouseOver handler.
		 * @param event The MouseEvent passed by the system.
		 */
		override protected function onMouseOver(event:MouseEvent):void
		{
			_over = true;
			invalidate();
			
			addEventListener(MouseEvent.ROLL_OUT, onMouseOut);
		}
		
		/**
		 * Internal mouseOut handler.
		 * @param event The MouseEvent passed by the system.
		 */
		override protected function onMouseOut(event:MouseEvent):void
		{
			_over = false;
			invalidate();
			
			removeEventListener(MouseEvent.ROLL_OUT, onMouseOut);
		}
		
		/**
		 * Internal mouseOut handler.
		 * @param event The MouseEvent passed by the system.
		 */
		override protected function onMouseDown(event:MouseEvent):void
		{
			_down = true;
			invalidate();
			
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}
		
		/**
		 * Internal mouseUp handler.
		 * @param event The MouseEvent passed by the system.
		 */
		override protected function onMouseUp(event:MouseEvent):void
		{
			if(_toggle  && _over) _selected = !_selected;
			_down = _selected;
			invalidate();
			
			stage.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}
	}
}
