package com.hisschemoller.view.components.ui 
{
	import com.hisschemoller.view.components.enum.Colors;
	import com.hisschemoller.view.components.text.BodyText;

	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.text.TextFieldAutoSize;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Apr 5, 2010
	 */
	public class EndLocator extends BasicLocator 
	{
		public function EndLocator(parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0, defaultHandler : Function = null)
		{
			super(parent, xpos, ypos, defaultHandler);
		}

		/**
		 * Creates and adds the child display objects of this component.
		 */
		override protected function addChildren() : void
		{
			_hitArea = new Sprite();
			_hitArea.graphics.beginFill(0x00FF00, 0);
			_hitArea.graphics.drawRect(0, 0, -20, 16);
			addChild(_hitArea);
			
			_background = new Sprite();
			_background.graphics.beginFill(0xFF0000);
			_background.graphics.moveTo(0, 0);
			_background.graphics.lineTo(0, 16);
			_background.graphics.lineTo(-14, 16);
			_background.graphics.lineTo(-20, 8);
			_background.graphics.lineTo(-14, 0);
			_background.graphics.lineTo(0, 0);
			addChild(_background);
			
			var label : BodyText = new BodyText(9.5, Colors.WHITE, 10);
			label.autoSize = TextFieldAutoSize.LEFT;
			label.text = "E";
			label.x = -13.5;
			label.y = -0.5;
			addChild(label);
			
			super.addChildren();
		}
	}
}
