package com.hisschemoller.view.components.ui 
{
	import assets.LocatorBarTile;

	import com.hisschemoller.view.components.enum.Colors;

	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Mar 24, 2010
	 */
	public class SelectionLocatorBar extends BasicLocatorBar 
	{
		public function SelectionLocatorBar(parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0)
		{
			super(parent, xpos, ypos);
		}

		/**
		 * Sets the size of the component.
		 * @param w The width of the component.
		 * @param h The height of the component.
		 */
		override public function setSize(w : Number, h : Number) : void
		{
			_startLocator.setSize(w, h);
			_endLocator.setSize(w, h);
			super.setSize(w, h);
		}
		
		/**
		 * 
		 */
		override public function draw() : void
		{
			var tileWidth : int = 100;
			
			if(_fill.width < _width)
			{
				var i : uint =  Math.floor(_fill.width / tileWidth);
				var n : uint = Math.ceil(_width / tileWidth);
				for(; i < n; i++)
				{
					var tile : LocatorBarTile = new LocatorBarTile();
					tile.x = i * tileWidth;
					_fill.addChild(tile);
				}
			}
			
			super.draw();
		}

		/**
		 * Creates and adds the child display objects of this component.
		 */
		override protected function addChildren() : void
		{
			var barHeight : int = 16;
			
			_track = new Sprite();
			_track.graphics.beginFill(Colors.WHITE);
			_track.graphics.drawRect(0, 0, 100, barHeight);
			addChild(_track);
			
			_fillMask = new Sprite();
			_fillMask.graphics.beginFill(Colors.GREEN);
			_fillMask.graphics.drawRect(0, 0, 100, barHeight);
			addChild(_fillMask);
			
			_fill = new Sprite();
			_fill.mask = _fillMask;
			addChild(_fill);
			
			_startLocator = new StartLocator(this, 0, 0);
			
			_endLocator = new EndLocator(this, 0, 0);
			
			super.addChildren();
		}
	}
}
